<template>
  <div class="feature-panel" id="onLoadFilters">
    <button class="feature-link back-btn" id="filters-back-button" tabindex="0" aria-label="Back"
      v-on:click="$router.push('/')">
      <img class="back-icon" src="@/assets/back-arrow.svg" alt="Back" />
      {{
        $t("Filters.back")
      }}
    </button>
    <div v-for="(filterGroup, index) in Object.entries(filters)" :key="index">
      <button id="highlight-setting" class="feature-link collapse-btn active" tabindex="0"
        v-on:click="selectFilterGroup(index)" :aria-expanded="displayedIndex == index">
        {{ $t("Filters." + (filterGroup as any)[1].label) }}
        <img src="@/assets/upward-arrow.svg" :alt="displayedIndex == index ? 'Collapse' : 'Expand'" />
      </button>
      <div class="filter-data-show" v-if="displayedIndex == index">
        <div class="show-highlight-settings">
          <div v-for="(filter, index) in (filterGroup as any)[1].filters" :key="index">
            <label class="custom-checkbox" tabindex="0" role="checkbox" :aria-label="$t('Filters.' + filter.label)">{{ $t("Filters." + filter.label) }}
              <input type="checkbox" id="check-all-ner" tabindex="-1" v-model="filter.active"
                v-on:change="updateSavedFilters()" :aria-checked="filter.active" />
              <span class="checkmark" :aria-checked="filter.active"></span>
            </label>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { Vue } from "vue-class-component";

export default class Filters extends Vue {
  filters = {};
  displayedIndex = -1;

  mounted() {
    chrome.runtime.sendMessage({ type: "get-filters" }, (response) => {
      if (response) {
        this.filters = response.activeFilters;
      }
    });
  }

  selectFilterGroup(index: number) {
    if (index == this.displayedIndex) {
      this.displayedIndex = -1;
    } else {
      this.displayedIndex = index;
    }
  }

  updateSavedFilters() {
    chrome.runtime.sendMessage({
      type: "set-filters",
      filters: this.filters,
    });
  }
}
</script>
<style>
.filter-data-show {
  height: 210px;
}
</style>
